#include <fstream>
#include <cstring>
#include <cassert>
#include <algorithm>

using namespace std;

ifstream f("euro.in");
ofstream g("euro.out");

const int maxP = 10000;
const int maxN = 5000;
const int mod = 1000000009;

const int P = maxP + 10;
const int N = maxN + 10;

int n, p, a[N], mi[P], sol[P], D[P];

void print() {
    for (int i = 1; i <= p; ++i) {
        if (sol[i] == 1 << 30) {
            sol[i] = -1;
        }
    }
    for (int i = 1; i <= p; ++i) {
        g << sol[i] << (i == p ? "\n" : " ");
    }
}

// Optim, N * P
void solve_100() {
    memset(mi, 0, sizeof(mi));
    for (int i = 1; i <= n; ++i) {
        for (int j = p - a[i]; j >= 1; --j) {
            if (mi[j]) {
                mi[j + a[i]] = max(mi[j + a[i]], mi[j]);
                sol[j + a[i]] = min(sol[j + a[i]], a[i] - mi[j]);
            }
        }
        mi[a[i]] = a[i];
        sol[a[i]] = 0;
    }
    print();
}

// P^2 * N
void solve_brut() {
    for (int i = 1; i <= p; ++i) {
        memset(D, 0, sizeof(D));
        D[0] = 1;
        int k = 0;
        for (int j = 1;j <= n; ++j) {
            while (! D[i] && k <= n) {
                ++k;
                for (int l = i - a[k]; l >= 0; --l) {
                    if (D[l]) {
                        D[l + a[k]] += D[l];
                        if (D[l + a[k]] >= mod) {
                            D[l + a[k]] -= mod;
                        }
                    }
                }
            }
            if (k > n) {
                break;
            }
            sol[i] = min(sol[i], a[k] - a[j]);
            for (int l = 0; l <= i - a[j]; ++l) {
                if (D[l]) {
                    D[l + a[j]] -= D[l];
                    if (D[l + a[j]] < 0) {
                        D[l + a[j]] += mod;
                    }
                }
            }
        }
    }
    print();
}

// 2 ^ N
void solve_back() {
    for (int cnf = 1; cnf < 1 << n; ++cnf) {
        int poz = 1;
        int minim = 0;
        int maxim;
        int sum = 0;
        int x = cnf;
        while (x) {
            if (x & 1) {
                if (!minim) {
                    minim = a[poz];
                }
                maxim = a[poz];
                sum += a[poz];
            }
            x >>= 1;
            poz++;
        }
        if (sum <= p) {
            sol[sum] = min(sol[sum], maxim - minim);
        }
    }
    print();
}

int main () {
    int T;
    f >> T;
    while (T --) {
        f >> n >> p;
        assert (n >= 1 && n <= maxN);
        assert (p >= 1 && p <= maxP);
        for (int i = 1; i <= n; ++i) {
            f >> a[i];
            assert (a[i] >= 1 && a[i] <= p);
        }
        for (int i = 1; i <= p; ++i) {
            sol[i] = 1 << 30;
        }
        sort (a + 1, a + n + 1);
        solve_back();
    }
    return 0;
}