//100 de puncte
#include <cstdio>
#include <cassert>
#include <vector>
#include <unordered_map>
#include <map>
#define MAXN 100005
#define INF 0x3f3f3f3f
using namespace std;

int n, m, last[MAXN], prvAp[8 * MAXN], ai[16 * MAXN], sol[MAXN], mxt;
vector<int> trOrder[MAXN];
unordered_map<int, int> nextNode[MAXN];
map< pair<int, int>, int > posNode;
vector<int> traversal, tStart;

void build_ai(int node, int l, int r) {
    if(l == r) {
        ai[node] = tStart[l];
        return;
    }

    int mid = (l + r) >> 1;
    build_ai(2 * node, l, mid);
    build_ai(2 * node + 1, mid + 1, r);

    ai[node] = max(ai[2 * node], ai[2 * node + 1]);
}

void query_ai(int node, int l, int r, int lq, int rq, int &ans) {
    if(lq <= l && r <= rq) {
        ans = max(ans, ai[node]);
        return;
    }

    int mid = (l + r) >> 1;
    if(lq <= mid) query_ai(2 * node, l, mid, lq, rq, ans);
    if(mid + 1 <= rq) query_ai(2 * node + 1, mid + 1, r, lq, rq, ans);
}

int main() {
    freopen("sushi.in", "r", stdin);
    freopen("sushi.out", "w", stdout);

    scanf("%d %d", &n, &m);

    if(n == 1) {
        printf("0\n");
        return 0;
    }

    assert(1 <= n && n <= 100000);
    assert(1 <= m && m <= 100000);

    for(int i = 1; i <= n; ++i) {
        int k, x;

        scanf("%d", &k);

        while(k--) {
            scanf("%d", &x);
            trOrder[i].push_back(x);

            assert(1 <= x && x <= n);
        }

        trOrder[i].push_back(trOrder[i][0]);

        for(int j = 0; j < (int) trOrder[i].size() - 1; ++j)
            nextNode[i][trOrder[i][j]] = trOrder[i][j + 1];
        
        trOrder[i].pop_back();
    }

    int u, rootU;
    int p, rootP;
    int cntRoot = 0;

    u = rootU = 1;
    p = rootP = trOrder[1].back();

    traversal.push_back(0);

    while(cntRoot <= 2) {
        if(u == rootU && p == rootP) ++cntRoot;

        traversal.push_back(u);
        int nxt = nextNode[u][p];

        p = u; u = nxt;
    }

    assert((int) traversal.size() == 4 * n - 2);

    int nt = 2 * (n - 1);

    for(int i = 1; i <= nt; ++i)
        posNode[make_pair(traversal[i], traversal[i + 1])] = i;

    tStart.resize((int) traversal.size(), -INF);

    for(int i = 1; i <= m; ++i) {
        int x, y, t;

        scanf("%d %d %d", &x, &y, &t);
        mxt = max(mxt, t);

        assert(1 <= x && x <= n);
        assert(1 <= y && y <= (int) trOrder[x].size());
        assert(0 <= t && t <= 100000);

        int pos = posNode[make_pair(x, trOrder[x][y - 1])];

        tStart[pos] = tStart[pos + nt] = max(tStart[pos], t);
    }

    for(int i = 1; i <= n; ++i) last[i] = -1;

    for(int i = 1; i <= 2 * nt; ++i) {
        prvAp[i] = last[traversal[i]];
        last[traversal[i]] = i;
    }

    for(int i = 1; i <= 2 * nt; ++i)
        tStart[i] -= i;

    build_ai(1, 1, 2 * nt);

    for(int i = 1; i <= 2 * nt; ++i) {
        if(prvAp[i] > 0) {
            if(prvAp[i] + 1 <= i - 1) {
                int x = -INF;
                query_ai(1, 1, 2 * nt, prvAp[i] + 1, i - 1, x);
                x += i;
                sol[traversal[i]] = max(sol[traversal[i]], x);
            }
        }
    }

    for(int i = 1; i <= n; ++i)
        printf("%d ", max(sol[i], mxt));
    printf("\n");

    return 0;
}