//100 de puncte O(N)
#include<stdio.h>
#include<string.h>
#include<unordered_map>
#include<vector>
using namespace std;

#define ll long long
#define NMAX 100005
#define pb push_back
#define INF 1000000005

unordered_map< ll, int > myHash;
int euler[2 * NMAX], sol[NMAX], n, m;
char viz[NMAX];
vector<int> v[NMAX];
int left[2 * NMAX], right[2 * NMAX], nrEuler;
int dfirst[NMAX], dlast[NMAX], entry[NMAX], last[NMAX];

inline void dfs(int nod, int lst)
{
	euler[++nrEuler] = nod;
	entry[nod] = last[nod] = nrEuler;
	viz[nod] = 1;
	
	int i, lim = v[nod].size(), start = 0;
	if(lst)
	{
		for(i = 0; i < lim; i++)
			if(v[nod][i] == lst)
				break;
		if(i < lim - 1)
			start = i + 1;
		else
			start = 0;
	}
	for(i = start; i < lim; i++)
		if(!viz[v[nod][i]])
		{
			dfs(v[nod][i], nod);
			euler[++nrEuler] = nod;
			last[nod] = nrEuler;
		}
	for(int i = 0; i < start; i++)
		if(!viz[v[nod][i]])
		{
			dfs(v[nod][i], nod);
			euler[++nrEuler] = nod;
			last[nod] = nrEuler;
		}
}

inline void dfsDinamica(int nod)
{
	viz[nod] = 1;
	int lim = v[nod].size();
	for(int i = 0; i < lim; i++)
		if(!viz[v[nod][i]])
		{
			dfsDinamica(v[nod][i]);
			dlast[nod] = max(dlast[nod], dlast[v[nod][i]] + last[nod] - last[v[nod][i]]);
			dfirst[nod] = max(dfirst[nod], dlast[v[nod][i]] + 1);
		}
	//printf("%d %d %d %d %d\n", nod, entry[nod], last[nod], dfirst[nod], dlast[nod]);
}

inline void read()
{
	int val, nr;
	
    scanf("%d%d",&n,&m);
    for(int i = 1; i <= n; i++)
    {
        scanf("%d",&nr);
        for(int j = 1; j <= nr; j++)
        {   
        	scanf("%d",&val);
        	v[i].pb(val);
        }
    }	
}

inline void prep()
{
	int nod1, nod2, timp;
	
    dfs(1, 0);
    
    for(int i = 1; i < nrEuler; i++)
		myHash[(ll)euler[i] * NMAX + euler[i + 1]] = i;
		
   	memset(viz, 0, sizeof(viz));		
   	memset(dfirst, -INF, sizeof(dfirst));
   	memset(dlast, -INF, sizeof(dlast));
   	memset(left, -INF, sizeof(left));
   	memset(right, -INF, sizeof(right));
	
	for(int i = 1; i <= m; i++)
        {
    		scanf("%d%d%d",&nod1,&nod2,&timp);
    		int index = myHash[(ll)nod1 * NMAX + v[nod1][nod2 - 1]];
    		dlast[nod1] = max(dlast[nod1], timp + last[nod1] - index);
    		dfirst[nod1] = max(dfirst[nod1], timp);
    		left[index] = right[index] = max(left[index], timp);
   	 	}
   	 	
	dfsDinamica(1);
	for(int i = 2; i <= nrEuler; i++)
		left[i] = max(left[i], left[i - 1] + 1);
	for(int i = nrEuler - 1; i >= 1; i--)
		right[i] = max(right[i + 1], right[i] + nrEuler - i);
}

inline void solve()
{
	for(int i = 1; i <= n; i++)
	{
		sol[i] = dfirst[i];
		sol[i] = max(sol[i], left[entry[i] - 1] + 1);
		sol[i] = max(sol[i], right[last[i] + 1] + entry[i] - 1);
	}
}

inline void write()
{
	for(int i = 1; i <= n; i++)
		printf("%d ", (sol[i] < 0 ? 0 : sol[i]));
	printf("\n");
}

int main ()
{
    freopen("sushi.in", "r", stdin);
    freopen("sushi.out", "w", stdout);

	read();
	prep();
	solve();
	write();

	return 0;
}

