//100 de puncte O(N log N)
#include<stdio.h>
#include<string.h>
#include<unordered_map>
#include<vector>
using namespace std;

#define ll long long
#define NMAX 100005
#define pb push_back
#define INF 1000000005

unordered_map< ll, int > myHash;
int euler[4 * NMAX], sol[NMAX], n, m;
char viz[NMAX];
vector<int> v[NMAX];
vector<int> aparitii[NMAX];
int aint[16 * NMAX], nrEuler;

inline void dfs(int nod, int last)
{
	euler[++nrEuler] = nod;
	viz[nod] = 1;
	int i, lim = v[nod].size(), start = 0;
	if(last)
	{
		for(i = 0; i < lim; i++)
			if(v[nod][i] == last)
				break;
		if(i < lim - 1)
			start = i + 1;
		else
			start = 0;
	}
	for(i = start; i < lim; i++)
		if(!viz[v[nod][i]])
		{
			dfs(v[nod][i], nod);
			euler[++nrEuler] = nod;
		}
	for(int i = 0; i < start; i++)
		if(!viz[v[nod][i]])
		{
			dfs(v[nod][i], nod);
			euler[++nrEuler] = nod;
		}

}

inline void read()
{
	int val, nr;
	
    scanf("%d%d",&n,&m);
    for(int i = 1; i <= n; i++)
    {
        scanf("%d",&nr);
        for(int j = 1; j <= nr; j++)
        {   
        	scanf("%d",&val);
        	v[i].pb(val);
        }
    }	
}

inline void update(int n, int st, int dr, int poz, int val)
{
	if(st == dr)
	{
		aint[n] = max(aint[n], val);
		return ;
	}
	int mij = (st + dr) / 2;
	if(poz <= mij)
		update(2 * n, st, mij, poz, val);
	else
		update(2 * n + 1, mij + 1, dr, poz, val);
	aint[n] = max(aint[2 * n] + dr - mij, aint[2 * n + 1]);
}

inline int query(int n, int st, int dr, int a, int b)
{
	if(a > b)
		return 0;
	if(a <= st && dr <= b)
		return aint[n] + b - dr;
	int mij = (st + dr) / 2, ans = -INF;
	if(a <= mij)
		ans = max(ans, query(2 * n, st, mij, a, b));
	if(b > mij)
		ans = max(ans, query(2 * n + 1, mij + 1, dr, a, b));
	return ans;
}


inline void prep()
{
	int nod1, nod2, timp;
	
    dfs(1, 0);
    
    for(int i = nrEuler + 1; i <= 2 * nrEuler - 1; i++)
    	euler[i] = euler[i - nrEuler + 1];
    
    for(int i = 1; i < nrEuler; i++)
		myHash[(ll)euler[i] * NMAX + euler[i + 1]] = i;
		
	for(int i = 1; i <= nrEuler; i++)
		aparitii[euler[i]].pb(i);

	memset(aint, -INF, sizeof(aint));
	for(int i = 1; i <= m; i++)
    {
    	scanf("%d%d%d",&nod1,&nod2,&timp);
    	int index = myHash[(ll)nod1 * NMAX + v[nod1][nod2 - 1]];
 		update(1, 1, 2 * nrEuler - 1, index, timp);
 		update(1, 1, 2 * nrEuler - 1, index + nrEuler - 1, timp);
    }
}

inline void solve()
{
	for(int i = 1; i <= n; i++)
	{
		aparitii[i].pb(aparitii[i][0] + nrEuler - 1);
		int lim = aparitii[i].size();
		for(int j = 0; j < lim - 1; j++)
			sol[i] = max(sol[i], query(1, 1, 2 * nrEuler - 1, aparitii[i][j] + 1, aparitii[i][j + 1]));
	}
}

inline void write()
{
	for(int i = 1; i <= n; i++)
		printf("%d ", sol[i]);
	printf("\n");
}

int main ()
{
    freopen("sushi.in", "r", stdin);
    freopen("sushi.out", "w", stdout);

	read();
	prep();
	solve();
	write();

	return 0;
}

