// 40 de puncte O(N*M) cu stop
#include<stdio.h>
#include<string.h>
#include<unordered_map>
#include<vector>
#include <ctime>
#include <algorithm>

using namespace std;

#define ll long long
#define NMAX 1000005
#define pb push_back
#define INF 1000000005

unordered_map< ll, int > myHash;
int euler[2 * NMAX], sol[NMAX], n, m;
char viz[NMAX];
vector<int> v[NMAX];
int left[2 * NMAX], right[2 * NMAX], nrEuler;
int dfirst[NMAX], dlast[NMAX], entry[NMAX], last[NMAX];

double programStartTime = clock();

inline void dfs(int nod, int lst) {
	euler[++nrEuler] = nod;
	viz[nod] = 1;
	
	int i, lim = v[nod].size(), start = 0;
	if(lst)
	{
		for(i = 0; i < lim; i++)
			if(v[nod][i] == lst)
				break;
		if(i < lim - 1)
			start = i + 1;
		else
			start = 0;
	}
	for(i = start; i < lim; i++)
		if(!viz[v[nod][i]])
		{
			dfs(v[nod][i], nod);
			euler[++nrEuler] = nod;
		}
	for(int i = 0; i < start; i++)
		if(!viz[v[nod][i]])
		{
			dfs(v[nod][i], nod);
			euler[++nrEuler] = nod;
		}
}

inline void read()
{
	int val, nr;
	
    scanf("%d%d",&n,&m);
    for(int i = 1; i <= n; i++)
    {
        scanf("%d",&nr);
        for(int j = 1; j <= nr; j++)
        {   
        	scanf("%d",&val);
        	v[i].pb(val);
        }
    }	
}

struct Platter {
    int startNode, nextNode, startTime;
    
    void read() {
        scanf("%d %d %d", &startNode, &nextNode, &startTime);
    }
    
    bool operator<(const Platter &o) const {
        return startTime > o.startTime;
    }
    
    void updateSolutions() {
        memset(viz, 0, sizeof(viz));
       	int index = myHash[(ll)startNode * NMAX + v[startNode][nextNode - 1]];
    	for (int j = index; j <= index + nrEuler; j++) {
    	    int currentNode = euler[j];
    		if (!viz[currentNode]) {
    		    if (startTime + j - index > sol[currentNode]) {
    		        sol[currentNode] = startTime + j - index;
    		    }
    			viz[currentNode] = 1;
    		}
    	}

    }
};

inline void prep() {
    dfs(1, 0);
    
    for(int i = nrEuler + 1; i <= 2 * nrEuler - 1; i++)
    	euler[i] = euler[i - nrEuler + 1];
    
    for(int i = 1; i < nrEuler; i++)
		myHash[(ll)euler[i] * NMAX + euler[i + 1]] = i;
		
	vector<Platter> platters(m);
		
	for(int i = 0; i < m; i++) {
	    platters[i].read();
   	}
   	
   	sort(platters.begin(), platters.end());
   	
   	int currentPlatter = 0;
   	
   	while (currentPlatter < m && (clock() - programStartTime) / CLOCKS_PER_SEC < 2.0) {
   	    platters[currentPlatter++].updateSolutions();
   	}
	fprintf(stderr, "Did %d iterations\n", currentPlatter);
}

inline void write()
{
	for(int i = 1; i <= n; i++)
		printf("%d ", (sol[i] < 0 ? 0 : sol[i]));
	printf("\n");
}

int main () {
    freopen("sushi.in", "r", stdin);
    freopen("sushi.out", "w", stdout);

	read();
	prep();
	write();

	return 0;
}

