#include <fstream>
#include <cassert>
#include <vector>

using namespace std;

ifstream f("calafat.in");
ofstream g("calafat.out");

const int Nmax = 200000;
const int Qmax = 200000;

const int Q = Qmax + 10;
const int N = Nmax + 10;

vector<pair<int, int> > qr[N];
pair<int, int> upd[N];
long long sol[Q], A[N * 4];
int last[N], n, q, l, r, x;

void update(int st, int dr, int po, int p, int x) {
    if (st == dr) {
        A[po] = x;
        return;
    }
    int mij = (st + dr) >> 1;
    if (p <= mij) {
        update(st, mij, po << 1, p, x);
    } else {
        update(mij + 1, dr, (po << 1) + 1, p, x);
    }
    A[po] = A[po << 1] + A[(po << 1) + 1];
}

void query(int st, int dr, int po, int l, int r, long long &sol) {
    if (st >= l && dr <= r) {
        sol += A[po];
        return;
    }
    int mij = (st + dr) >> 1;
    if (l <= mij) {
        query(st, mij, po << 1, l, r, sol);
    }
    if (r > mij) {
        query(mij + 1, dr, (po << 1) + 1, l, r, sol);
    }
}

int main () {
    f >> n >> q;
    assert(n >= 1 && n <= Nmax);
    assert(q >= 1 && q <= Qmax);
    for (int i = 1; i <= n; ++i) {
        f >> x;
        assert(x >= 1 && x <= Nmax);
        if (!last[x]) {
            last[x] = i;
        } else {
            upd[i] = make_pair(last[x], i - last[x]);
            last[x] = i;
        }
    }
    for (int i = 1; i <= q; ++i) {
        f >> l >> r;
        assert(l <= r && 1 <= l && l <= n && 1 <= r && r <= n);
        qr[r].push_back(make_pair(l, i));
    }
    for (int i = 1; i <= n; ++i) {
        if (upd[i].first) {
            update(1, n, 1, upd[i].first, upd[i].second);
        }
        for (auto &it : qr[i]) {
            query(1, n, 1, it.first, i, sol[it.second]);
        }
    }
    for (int i = 1; i <= q; ++i) {
        g << sol[i] << "\n";
    }
    return 0;
}